library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
entity Hamming is
    Port ( clk : in std_logic;
           din : in std_logic_vector(23 downto 0);
           cc_ecc : in std_logic;
           dout : out std_logic_vector(19 downto 0);
           cc_rxena : in std_logic);
end Hamming;

architecture my_arch of Hamming is
signal din_q: std_logic_vector(23 downto 0);
signal d: std_logic_vector(24 downto 1);
signal q: std_logic_vector(18 downto 1);
signal c: std_logic_vector(5 downto 1);
signal pp: std_logic;
begin
process(clk)
begin
  if(clk'event and clk = '1')then
     din_q <= din;
     d <= din_q;
	 c(1) <= d(1) xor d(3) xor d(5) xor d(7) xor d(9) xor d(11) xor
	         d(13) xor d(15) xor d(17) xor d(19) xor d(21) xor d(23);
	 c(2) <= d(2) xor d(3) xor d(6) xor d(7) xor d(10) xor d(11) xor
	         d(14) xor d(15) xor d(18) xor d(19) xor d(22) xor d(23);
	 c(3) <= d(4) xor d(5) xor d(6) xor d(7) xor d(12) xor d(13) xor
	         d(14) xor d(15) xor d(20) xor d(21) xor d(22) xor d(23);
	 c(4) <= d(8) xor d(9) xor d(10) xor d(11) xor d(12) xor d(13) xor
	         d(14) xor d(15);
	 c(5) <= d(16) xor d(17) xor d(18) xor d(19) xor d(20) xor d(21) xor
	         d(22) xor d(23);
	 pp   <= d(2) xor d(4) xor d(6) xor d(8) xor d(10) xor d(12) xor
	         d(14) xor d(16) xor d(18) xor d(20) xor d(22) xor d(24);
	 q(1) <= d(3);
	 q(2) <= d(5);
	 q(3) <= d(6);
	 q(4) <= d(7);
	 q(5) <= d(9);
	 q(6) <= d(10);
	 q(7) <= d(11);
	 q(8) <= d(12);
	 q(9) <= d(13);
	 q(10) <= d(14);
	 q(11) <= d(15);
	 q(12) <= d(17);
	 q(13) <= d(18);
	 q(14) <= d(19);
	 q(15) <= d(20);
	 q(16) <= d(21);
	 q(17) <= d(22);
	 q(18) <= d(23);
  end if;
end process;
process(clk,cc_rxena)
begin
  if(cc_rxena = '0')then
    dout <= (others => '0');
  elsif(clk'event and clk = '1')then
    if(c = "00011" and cc_ecc = '1')then
	   dout(0) <= not q(1);
	 else
	   dout(0) <= q(1);
	 end if;
    if(c = "00101" and cc_ecc = '1')then
	   dout(1) <= not q(2);
	 else
	   dout(1) <= q(2);
	 end if;
    if(c = "00110" and cc_ecc = '1')then
	   dout(2) <= not q(3);
	 else
	   dout(2) <= q(3);
	 end if;
    if(c = "00111" and cc_ecc = '1')then
	   dout(3) <= not q(4);
	 else
	   dout(3) <= q(4);
	 end if;
    if(c = "01001" and cc_ecc = '1')then
	   dout(4) <= not q(5);
	 else
	   dout(4) <= q(5);
	 end if;
    if(c = "01010" and cc_ecc = '1')then
	   dout(5) <= not q(6);
	 else
	   dout(5) <= q(6);
	 end if;
    if(c = "01011" and cc_ecc = '1')then
	   dout(6) <= not q(7);
	 else
	   dout(6) <= q(7);
	 end if;
    if(c = "01100" and cc_ecc = '1')then
	   dout(7) <= not q(8);
	 else
	   dout(7) <= q(8);
	 end if;
    if(c = "01101" and cc_ecc = '1')then
	   dout(8) <= not q(9);
	 else
	   dout(8) <= q(9);
	 end if;
    if(c = "01110" and cc_ecc = '1')then
	   dout(9) <= not q(10);
	 else
	   dout(9) <= q(10);
	 end if;
    if(c = "01111" and cc_ecc = '1')then
	   dout(10) <= not q(11);
	 else
	   dout(10) <= q(11);
	 end if;
    if(c = "10001" and cc_ecc = '1')then
	   dout(11) <= not q(12);
	 else
	   dout(11) <= q(12);
	 end if;
    if(c = "10010" and cc_ecc = '1')then
	   dout(12) <= not q(13);
	 else
	   dout(12) <= q(13);
	 end if;
    if(c = "10011" and cc_ecc = '1')then
	   dout(13) <= not q(14);
	 else
	   dout(13) <= q(14);
	 end if;
    if(c = "10100" and cc_ecc = '1')then
	   dout(14) <= not q(15);
	 else
	   dout(14) <= q(15);
	 end if;
    if(c = "10101" and cc_ecc = '1')then
	   dout(15) <= not q(16);
	 else
	   dout(15) <= q(16);
	 end if;
    if(c = "10110" and cc_ecc = '1')then
	   dout(16) <= not q(17);
	 else
	   dout(16) <= q(17);
	 end if;
    if(c = "10111" and cc_ecc = '1')then
	   dout(17) <= not q(18);
	 else
	   dout(17) <= q(18);
	 end if;
-- this check does not detect all double bit errors
-- if two odd data bits are wrong, no error will be detected
-- since this is how LTB is coded, no change is possible S.X.Wu
	 dout(18) <= c(1) xor pp;
    if(c /= "00000" and c(1) = pp )then
	   dout(19) <= '1';
	 else
	   dout(19) <= '0';
	 end if;
  end if;
end process;
end my_arch;
